package com.zhongzheng.modules.goods.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.zhongzheng.modules.goods.bo.*;
import com.zhongzheng.modules.goods.domain.Goods;
import com.zhongzheng.modules.goods.vo.GoodsVo;

import java.util.Collection;
import java.util.List;

/**
 * 商品Service接口
 *
 * @author hjl
 * @date 2021-10-12
 */
public interface IGoodsService extends IService<Goods> {
	/**
	 * 查询单个
	 * @return
	 */
	GoodsVo queryById(Long goodsId);

	List<GoodsVo> selectList(GoodsQueryBo bo);

	GoodsVo selectDetail(Long goodsId);

	/**
	 * 查询列表
	 */
	List<GoodsVo> queryList(GoodsQueryBo bo);

	/**
	 * 根据新增业务对象插入商品
	 * @param bo 商品新增业务对象
	 * @return
	 */
	Boolean insertByAddBo(GoodsAddBo bo);

	Boolean insertBankByAddBo(GoodsBankAddBo bo);

	/**
	 * 根据编辑业务对象修改商品
	 * @param bo 商品编辑业务对象
	 * @return
	 */
	Boolean updateByEditBo(GoodsEditBo bo);

	Boolean updateBankByEditBo(GoodsBankEditBo bo);

	/**
	 * 校验并删除数据
	 * @param ids 主键集合
	 * @param isValid 是否校验,true-删除前校验,false-不校验
	 * @return
	 */
	Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);
}
